EvaluateSystemScript('colors.js'); // future Sphere 1.6 systemscript
EvaluateSystemScript('typeof.js'); // future Sphere 1.6 systemscript

function Graph(init){
	// Always do UT = new Graph(). If the programmer forgets the 'new', then do it for them.
	if(this instanceof Graph == false) {
		return new Graph(init);
	};

	this.width = GetScreenWidth();
	this.height = GetScreenHeight();
	this.center = {
		X: this.width >>1,
		Y: this.height >>1
	};


	this.raster = { 
		show:true,
		axisline:{
			color: CreateColorNamed('PowderBlue'),
			style: 1,
			thickness: 1
		},
		markerline:{
			color: CreateColorNamed('MidnightBlue'),
			style: 1,
			thickness: 1,
			length: 6
		},
		gridline:{
			color: CreateColor(10,10,255,40),
			style: 2,
			thickness: 1,
			length: 6
		},
		scale: {
			X: 10,
			Y : 10
		}
	};

	this.line = {
		color: CreateColorNamed('Red'),
	};

	this.backgroundColor = CreateColorNamed('Black');
	this.canvas = CreateSurface(this.width, this.height, this.backgroundColor);
	this.step = 1;
	this.F = function(x){ return 0 }; // y = 0;
	this.from = -100;
	this.to = 100;

	this.clearCanvas = function(color){
		var bgcolor = IsColor(color) ? color : IsString(color) ? CreateColorNamed(color) : this.backgroundColor;
		this.canvas.rectangle(0, 0, this.width, this.height, bgcolor || this.backgroundColor);
	}

	this.drawRasterOnCanvas = function(){
		this.canvas.line(0, this.center.Y, this.canvas.width, this.center.Y, this.raster.axisline.color);
		this.canvas.line(this.center.X, this.canvas.height, this.center.X, 0, this.raster.axisline.color);
		for( var i= 0; i< this.width; i+=this.raster.scale.X){ 
			this.canvas.line(i, 0, i, this.canvas.height, this.raster.gridline.color);
			this.canvas.line(i,  -(this.raster.markerline.length>>1 )+ this.center.Y, i,  (this.raster.markerline.length>>1) + this.center.Y, this.raster.markerline.color);
		}
		for( var j= 0; j< this.height; j+=this.raster.scale.Y){ 
			this.canvas.line(0, j, this.canvas.width, j, this.raster.gridline.color);
			this.canvas.line(-(this.raster.markerline.length>>1 )+ this.center.X, j,  (this.raster.markerline.length>>1) + this.center.X, j, this.raster.markerline.color);
		}
	}

	this.plot = function(myfunc, from, to){
		myfunc = "with(Math){ return (" + myfunc + ")};";
		var F = new Function("x", myfunc);
		this.F = F;
		if( !IsNumber(from) )
			from = this.from;
		if( !IsNumber(to) )
			to = this.to;
		var x = this.from;
		var p0 = { x:x, y:F(from) };
		var p1 = { x:undefined, y:undefined };
		for (x=from + this.step;x<to;x+=this.step){
			p1.x = x;
			p1.y = F(x);
			//Abort(myfunc +">"+ this.F);
			//Abort(p1.x +","+p1.y)
			this.canvas.line(p0.x + this.center.X, this.center.Y - p0.y, p1.x + this.center.X, this.center.Y - p1.y, this.line.color);
			p0.x = p1.x;
			p0.y = p1.y;
		}
	}

	this.blit = function(x, y){
		x = x|0
		y = y|0
		this.canvas.blit(x, y);
	}
	
	this.pressAnyKey = function(){
	// clear Keyboard Buffer
	while ( AreKeysLeft() ) { GetKey(); }
	var bg = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
	var c = 0;
	while (IsMouseButtonPressed(MOUSE_LEFT)) {}
	// Wait until a key is pressed
	while (!AreKeysLeft() && !IsMouseButtonPressed(MOUSE_LEFT)) {
		if(++c>60) { 
			c=0; 
			bg.blit(0,0); 
			FlipScreen();
		}
	}
}

	// treat init as an object with variables and methods
	var action;
	for (action in init){
		if( (typeof this[action] == 'function') && (typeof init[action] == 'object') )
			this[action].apply(this, init[action]);
		else
			this[action] = init[action];
	}
	
	this.drawRasterOnCanvas();
}

// Wipe canvas screen clean
Graph.prototype.wipe = function(color){
	this.clearCanvas(color);
	this.drawRasterOnCanvas()
}

// Draw a circle
Graph.prototype.circle = function(radius, at_x, at_y){

}

